---
title: Using HTTP cookies
slug: Web/HTTP/Cookies
tags:
  - Advertising
  - Browser
  - Cookies
  - Cookies Article
  - Guide
  - HTTP
  - History
  - JavaScript
  - Privacy
  - Protocols
  - Server
  - Storage
  - Web Development
  - data
  - request
  - tracking
---
<div>{{HTTPSidebar}}</div>

<p class="summary"><span class="seoSummary">An <dfn>HTTP cookie</dfn> (web cookie, browser cookie) is a small piece of data that a server sends to the user's web browser. The browser may store it and send it back with later requests to the same server.</span> Typically, it's used to tell if two requests came from the same browser — keeping a user logged-in, for example. It remembers stateful information for the <a href="/en-US/docs/Web/HTTP/Overview#HTTP_is_stateless_but_not_sessionless">stateless</a> HTTP protocol.</p>

<p>Cookies are mainly used for three purposes:</p>

<dl>
 <dt>Session management</dt>
 <dd>Logins, shopping carts, game scores, or anything else the server should remember</dd>
 <dt>Personalization</dt>
 <dd>User preferences, themes, and other settings</dd>
 <dt>Tracking</dt>
 <dd>Recording and analyzing user behavior</dd>
</dl>

<p>Cookies were once used for general client-side storage. While this was legitimate when they were the only way to store data on the client, it is now recommended to use modern storage APIs. Cookies are sent with every request, so they can worsen performance (especially for mobile data connections). Modern APIs for client storage are the <a href="/en-US/docs/Web/API/Web_Storage_API" title="DOM Storage">Web Storage API</a> (<code>localStorage</code> and <code>sessionStorage</code>) and <a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB</a>.</p>

<div class="note">
<p>To see stored cookies (and other storage that a web page can use), you can enable the <a href="/en-US/docs/Tools/Storage_Inspector">Storage Inspector</a> in Developer Tools and select Cookies from the storage tree.</p>
</div>

<h2 id="Creating_cookies">Creating cookies</h2>

<p>After receiving an HTTP request, a server can send one or more {{HTTPHeader("Set-Cookie")}} headers with the response. The cookie is usually stored by the browser, and then the cookie is sent with requests made to the same server inside a {{HTTPHeader("Cookie")}} HTTP header. An expiration date or duration can be specified, after which the cookie is no longer sent. Additional restrictions to a specific domain and path can be set, limiting where the cookie is sent. For details about the header attributes mentioned below, refer to the {{HTTPHeader("Set-Cookie")}} reference article.</p>

<h3 id="The_Set-Cookie_and_Cookie_headers">The <code>Set-Cookie</code> and <code>Cookie</code> headers</h3>

<p>The {{HTTPHeader("Set-Cookie")}} HTTP response header sends cookies from the server to the user agent. A simple cookie is set like this:</p>

<pre class="syntaxbox notranslate">Set-Cookie: &lt;cookie-name&gt;=&lt;cookie-value&gt;</pre>

<p>This shows the server sending headers to tell the client to store a pair of cookies:</p>

<pre class="notranslate">HTTP/2.0 200 OK
Content-Type: text/html
Set-Cookie: yummy_cookie=choco
Set-Cookie: tasty_cookie=strawberry

[page content]</pre>

<p id="The_client_sends_back_to_the_server_its_cookies_previously_stored">Then, with every subsequent request to the server, the browser sends back all previously stored cookies to the server using the {{HTTPHeader("Cookie")}} header.</p>

<pre class="notranslate">GET /sample_page.html HTTP/2.0
Host: www.example.org
Cookie: yummy_cookie=choco; tasty_cookie=strawberry</pre>

<div class="note"><strong>Note:</strong> Here's how to use the <code>Set-Cookie</code> header in various server-side applications:

<ul>
 <li><a href="https://secure.php.net/manual/en/function.setcookie.php">PHP</a></li>
 <li><a href="https://nodejs.org/dist/latest-v8.x/docs/api/http.html#http_response_setheader_name_value">Node.JS</a></li>
 <li><a href="https://docs.python.org/3/library/http.cookies.html">Python</a></li>
 <li><a href="https://api.rubyonrails.org/classes/ActionDispatch/Cookies.html">Ruby on Rails</a></li>
</ul>
</div>

<h3 id="Define_the_lifetime_of_a_cookie">Define the lifetime of a cookie</h3>

<p>The lifetime of a cookie can be defined in two ways:</p>

<ul>
 <li><em>Session</em> cookies are deleted when the current session ends. The browser defines when the "current session" ends, and some browsers use <em>session restoring</em> when restarting, which can cause session cookies to last indefinitely long.</li>
 <li><em>Permanent</em> cookies are deleted at a date specified by the <code>Expires</code> attribute, or after a period of time specified by the <code>Max-Age</code> attribute.</li>
</ul>

<p>For example:</p>

<pre class="notranslate">Set-Cookie: id=a3fWa; Expires=Thu, 31 Oct 2021 07:28:00 GMT;</pre>

<div class="note">
<p><strong>Note</strong>: When an <code>Expires</code> date is set, the time and date set is relative to the client the cookie is being set on, not the server.</p>
</div>

<p>If your site authenticates users, it should regenerate and resend session cookies, even ones that already exist, whenever the user authenticates. This technique helps prevent <a href="/en-US/docs/Web/Security/Types_of_attacks#Session_fixation">session fixation attacks</a>, where a third party can reuse a user's session.</p>

<h3 id="Restrict_access_to_cookies">Restrict access to cookies</h3>

<p>There are a couple of ways to ensure that cookies are sent securely and are not accessed by unintended parties or scripts: the <code>Secure</code> attribute and the <code>HttpOnly</code> attribute.</p>

<p>A cookie with the <code>Secure</code> attribute is sent to the server only with an encrypted request over the HTTPS protocol, never with unsecured HTTP (except on localhost), and therefore can't easily be accessed by a {{Glossary("MitM", "man-in-the-middle")}} attacker. Insecure sites (with <code>http:</code> in the URL) can't set cookies with the <code>Secure</code> attribute. However, do not assume that <code>Secure</code> prevents all access to sensitive information in cookies; for example, it can be read and modified by someone with access to the client's hard disk (or JavaScript if the <code>HttpOnly</code> attribute is not set).</p>

<p>A cookie with the <code>HttpOnly</code> attribute is inaccessible to the JavaScript {{domxref("Document.cookie")}} API; it is sent only to the server. For example, cookies that persist server-side sessions don't need to be available to JavaScript, and should have the <code>HttpOnly</code> attribute. This precaution helps mitigate cross-site scripting (<a href="/en-US/docs/Web/Security/Types_of_attacks#Cross-site_scripting_(XSS)">XSS</a>) attacks.</p>

<p>Here is an example:</p>

<pre class="notranslate">Set-Cookie: id=a3fWa; Expires=Thu, 21 Oct 2021 07:28:00 GMT; Secure; HttpOnly</pre>

<h3 id="Define_where_cookies_are_sent">Define where cookies are sent</h3>

<p>The <code>Domain</code> and <code>Path</code> attributes define the <em>scope</em> of the cookie: what URLs the cookies should be sent to.</p>

<h4 id="Domain_attribute">Domain attribute</h4>

<p>The <code>Domain</code> attribute specifies which hosts are allowed to receive the cookie. If unspecified, it defaults to the same {{Glossary("origin")}} that set the cookie, <em>excluding subdomains</em>. If <code>Domain</code> <em>is</em> specified, then subdomains are always included. Therefore, specifying <code>Domain</code> is less restrictive than omitting it. However, it can be helpful when subdomains need to share information about a user.</p>

<p>For example, if <code>Domain=mozilla.org</code> is set, then cookies are available on subdomains like <code>developer.mozilla.org</code>.</p>

<h4 id="Path_attribute">Path attribute</h4>

<p>The <code>Path</code> attribute indicates a URL path that must exist in the requested URL in order to send the <code>Cookie</code> header. The <code>%x2F</code> ("/") character is considered a directory separator, and subdirectories match as well.</p>

<p>For example, if <code>Path=/docs</code> is set, these paths match:</p>

<ul>
 <li><code>/docs</code></li>
 <li><code>/docs/Web/</code></li>
 <li><code>/docs/Web/HTTP</code></li>
</ul>

<h4 id="SameSite_attribute">SameSite attribute</h4>

<p>The <a href="/en-US/docs/Web/HTTP/Headers/Set-Cookie/SameSite"><code>SameSite</code> </a>attribute lets servers specify whether/when cookies are sent with cross-origin requests (where {{Glossary("Site")}} is defined by the registrable domain), which provides some protection against cross-site request forgery attacks ({{Glossary("CSRF")}}).</p>

<p>It takes three possible values: <code>Strict</code>, <code>Lax</code>, and <code>None</code>. With <code>Strict</code>, the cookie is sent only to the same site as the one that originated it; <code>Lax</code> is similar, except that cookies are sent when the user <em>navigates</em> to the cookie's origin site, for example, by following a link from an external site; <code>None</code> specifies that cookies are sent on both originating and cross-site requests, but <em>only in secure contexts</em> (i.e. if <code>SameSite=None</code> then the <code>Secure</code> attribute must also be set). If no <code>SameSite</code> attribute is set then the cookie is treated as <code>Lax</code>.</p>

<p>Here is an example:</p>

<pre class="notranslate">Set-Cookie: mykey=myvalue; SameSite=Strict</pre>

<div class="notecard note">
<p>Standard related to <code>SameSite</code> recently changed (MDN documents the new behaviour above). See the cookies <a href="/en-US/docs/Web/HTTP/Headers/Set-Cookie/SameSite#Browser_compatibility">Browser compatibility</a> table for information about how the attribute is handled in specific browser versions:</p>

<ul>
 <li><code>SameSite=Lax</code> is the new default if <code>SameSite</code> is not specified. Previously the default was that cookies were sent for all requests.</li>
 <li>Cookies with <code>SameSite=None</code> must now also specify the <code>Secure</code> attribute (they require a secure context).</li>
</ul>
</div>

<h4 id="Cookie_prefixes">Cookie prefixes</h4>

<p>The design of the cookie mechanism is such that a server is unable to confirm that a cookie was set on a secure origin or even to tell <em>where</em> a cookie was originally set.</p>

<p>A vulnerable application on a sub-domain can set a cookie with the <code>Domain</code> attribute, which gives access to that cookie on all other subdomains. This mechanism can be abused in a <em>session fixation</em> attack. See <a href="/en-US/docs/Web/Security/Types_of_attacks#Session_fixation">session fixation</a> for primary mitigation methods.</p>

<p>As a <a href="https://en.wikipedia.org/wiki/Defense_in_depth_(computing)">defence-in-depth measure</a>, however, it is possible to use <em>cookie prefixes</em> to assert specific facts about the cookie. Two prefixes are available:</p>

<dl>
 <dt><code>__Host-</code></dt>
 <dd>If a cookie name has this prefix, it is accepted in a {{HTTPHeader("Set-Cookie")}} header only if it is also marked with the <code>Secure</code> attribute, was sent from a secure origin, does <em>not</em> include a <code>Domain</code> attribute, and has the <code>Path</code> attribute set to <code>/</code>. In this way, these cookies can be seen as "domain-locked".</dd>
 <dt><code>__Secure-</code></dt>
 <dd>If a cookie name has this prefix, it is accepted in a {{HTTPHeader("Set-Cookie")}} header only if it is marked with the <code>Secure</code> attribute and was sent from a secure origin. This is weaker than the <code>__Host-</code> prefix.</dd>
</dl>

<p>Cookies with these prefixes that are not compliant with their restrictions are rejected by the browser. Note that this ensures that if a subdomain were to create a cookie with a prefix, it would either be confined to the subdomain or be ignored completely. As the application server checks for a specific cookie name only when determining if the user is authenticated or a CSRF token is correct, this effectively acts as a defence measure against session fixation.</p>

<div class="note">
<p>On the application server, the web application <em>must</em> check for the full cookie name including the prefix—user agents <em>do not</em> strip the prefix from the cookie before sending it in a request's {{HTTPHeader("Cookie")}} header.</p>
</div>

<p>For more information about cookie prefixes and the current state of browser support, see the <a href="/en-US/docs/Web/HTTP/Headers/Set-Cookie#Cookie_prefixes">Prefixes section of the Set-Cookie reference article</a>.</p>

<h4 id="JavaScript_access_using_Document.cookie">JavaScript access using Document.cookie</h4>

<p>New cookies can be created via JavaScript using the {{domxref("Document.cookie")}} property, and existing cookies can be accessed from JavaScript as well, if the <code>HttpOnly</code> flag is not set.</p>

<pre class="brush: js notranslate">document.cookie = "yummy_cookie=choco";
document.cookie = "tasty_cookie=strawberry";
console.log(document.cookie);
// logs "yummy_cookie=choco; tasty_cookie=strawberry"</pre>

<p>Cookies created via JavaScript cannot include the <code>HttpOnly</code> flag.</p>

<p>Please note the security issues in the <a href="/en-US/docs/Web/HTTP/Cookies#Security">Security</a> section below. Cookies available to JavaScript can be stolen through XSS.</p>

<h2 id="Security">Security</h2>

<div class="note">
<p>Information should be stored in cookies with the understanding that all cookie values are visible to, and can be changed by, the end-user. Depending on the application, it may be desirable to use an opaque identifier which is looked-up by the server or to investigate alternative authentication/confidentiality mechanisms such as JSON Web Tokens.</p>
</div>

<p>Ways to mitigate attacks involving cookies:</p>

<ul>
 <li>Use the <code>HttpOnly</code> attribute to prevent access to cookie values via JavaScript.</li>
 <li>Cookies that are used for sensitive information (such as indicating authentication) should have a short lifetime, with the <code>SameSite</code> attribute set to <code>Strict</code> or <code>Lax</code>. (See <a href="#">SameSite cookies</a>, above.) In <a href="/en-US/docs/Web/HTTP/Headers/Set-Cookie#Browser_compatibility">browsers that support SameSite</a>, this has the effect of ensuring that the authentication cookie is not sent with cross-origin requests, so such a request is effectively unauthenticated to the application server.</li>
</ul>

<h2 id="Tracking_and_privacy">Tracking and privacy</h2>

<h3 id="Third-party_cookies">Third-party cookies</h3>

<p>A cookie is associated with a domain. If this domain is the same as the domain of the page you are on, the cookie is called a <em>first-party cookie</em>. If the domain is different, it is a <em>third-party cookie</em>. While the server hosting a web page sets first-party cookies, the page may contain images or other components stored on servers in other domains (for example, ad banners), which may set third-party cookies. These are mainly used for advertising and tracking across the web. See for example the <a href="https://policies.google.com/technologies/types">types of cookies used by Google</a>.</p>

<p>A third party server can build up a profile of a user's browsing history and habits based on cookies sent to it by the same browser when accessing multiple sites. Firefox, by default, blocks third-party cookies that are known to contain trackers. Third-party cookies (or just tracking cookies) may also be blocked by other browser settings or extensions. Cookie blocking can cause some third-party components (such as social media widgets) to not function as intended.</p>

<div class="notecard note">
<p>Servers can (and should) set the cookie <a href="/en-US/docs/Web/HTTP/Headers/Set-Cookie/SameSite">SameSite attribute</a> to specify whether or not cookies may be sent to third party sites.</p>
</div>

<h3 id="Cookie-related_regulations">Cookie-related regulations</h3>

<p>Legislation or regulations that cover the use of cookies include:</p>

<ul>
 <li>The General Data Privacy Regulation (GDPR) in the European Union</li>
 <li>The ePrivacy Directive in the EU</li>
 <li>The California Consumer Privacy Act</li>
</ul>

<p>These regulations have global reach, because they apply to any site on the <em>World Wide</em> Web that is accessed by users from these jurisdictions (the EU and California, with the caveat that California's law applies only to entities with gross revenue over 25 million USD, among other things.)</p>

<p>These regulations include requirements such as:</p>

<ul>
 <li>Notifying users that your site uses cookies.</li>
 <li>Allowing users to opt out of receiving some or all cookies.</li>
 <li>Allowing users to use the bulk of your service without receiving cookies.</li>
</ul>

<p>There may be other regulations governing the use of cookies in your locality. The burden is on you to know and comply with these regulations. There are companies that offer "cookie banner" code that helps you comply with these regulations.</p>

<h2 id="Other_ways_to_store_information_in_the_browser">Other ways to store information in the browser</h2>

<p>Another approach to storing data in the browser is the <a href="/en-US/docs/Web/API/Web_Storage_API/Using_the_Web_Storage_API">Web Storage API</a>. The <a href="/en-US/docs/Web/API/Window/sessionStorage">window.sessionStorage</a> and <a href="/en-US/docs/Web/API/Window/localStorage">window.localStorage</a> properties correspond to session and permanent cookies in duration, but have larger storage limits than cookies, and are never sent to a server. More structured and larger amounts of data can be stored using the <a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB API</a>, or a library built on it.</p>

<p>Other techniques have been created to cause cookies to be recreated after they are deleted, known as "zombie" cookies. These techniques violate the principles of user privacy and user control, may violate data privacy regulations, and could expose a website using them to legal liability.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Set-Cookie")}}</li>
 <li>{{HTTPHeader("Cookie")}}</li>
 <li>{{domxref("Document.cookie")}}</li>
 <li>{{domxref("Navigator.cookieEnabled")}}</li>
 <li><a href="/en-US/docs/Web/HTTP/Headers/Set-Cookie/SameSite">SameSite cookies</a></li>
 <li><a href="/en-US/docs/Tools/Storage_Inspector">Inspecting cookies using the Storage Inspector</a></li>
 <li><a class="external" href="https://tools.ietf.org/html/rfc6265">Cookie specification: RFC 6265</a></li>
 <li><a href="https://en.wikipedia.org/wiki/HTTP_cookie">HTTP cookie on Wikipedia</a></li>
 <li><a href="https://gdpr.eu/cookies/">Cookies, the GDPR, and the ePrivacy Directive</a></li>
</ul>
